package jcm.mod.energy;

import java.util.*;
import jcm.core.cur.*;
import jcm.core.ob.*;
import jcm.core.par.*;
import jcm.core.reg.region;
import jcm.core.reg.regman;
import jcm.mod.energy.enerData.*;

import jcm.mod.socio.popgdp;
import static jcm.mod.energy.enerData.*;
import static jcm.mod.energy.enerData.eregion.*;
import static jcm.mod.energy.enerData.info_type.*;
import static jcm.mod.energy.enerData.sub_sector.*;
import static jcm.mod.energy.enerData.source.*;
import static jcm.mod.energy.enerData.WEO_scenario.*;
import static jcm.mod.energy.electricity.methods.*;
import static  jcm.mod.energy.electricity.techpotopts.*;
import static jcm.gui.gen.colfont.*;
import static jcm.core.report.*;

public class transport extends module {

    public curveset transport_energy_use = new curveset("transport_energy_use", "tera&Watt_hours", 2010, 2050);
    public curveset transport_CO2 = new curveset("CO2_transport", "mega&ton&CO2", 2010, 2050);
    public curveset totcostplot = new curveset("costs_transport", "mega&dollar", 2010, 2050);


    enerGeneral ea; popgdp pg; fuels fu;

    //======== ENUMS ========
    //infrastruc - mostly in km, but what about ports, airports?
    //blend infrastruc and vehicles - investement goes together?
    //some simplification - eg trolleybus - busway running on electricity?
    // rail - elec / no nelec can be used pass and freight, assume highspeed and metro all electric
    //cable - includes teleferico, funicular, ...
    enum transmode {
        road_highway, road_rural, road_urban, busway, bikelane, footpath,
        rail_highspeed, rail_regional_elec, rail_non_elec,  surface_metro, underground, tram, cable,
        inland_waterway, port_freight, ferry,
        air_freight, air_passenger,
        telecommunication //here or elsewhere?
    };
    //what about vehicles eg car, bus, minibus ... - all passenger on same route

    enum fuelsource { electricity, hydrogen, gasoline, diesel, bunkeroil,  ethanol, biodiesel, mixbiofuel}

    enum demand { pass_local, pass_regional, pass_longdistance, freight_local, freight_regional, freight_longdistance}
     // ======== LOOP METHODS ===================
    
    public void initsetup() {
        ea=gm(enerGeneral.class);
        follows(ea);
    }

    //=========================
    void calcworld() {

    }

     void fillplots() {
    
     }

     //======= TRANSPORT SECTOR==================
     // transport sector in one country 

      class transec {
          Map<transmode, tranmod> mods;
          float urbandensity;
          float popdensity; // pop / popdensity => area => affects need for transport?
          float urbanfraction; //how use this ?
          ;


      }  //end transec

     class tranmod {
         float infrastruc_km; // length in km or numbers in case of ports / airports ?
         Map<fuelsource, Float> fleet; //fleet size - according to each fuel type / mode
         Map<fuelsource, Float>efficiency; //converting fuel in to movement - or to pass-km or freight-ton km
         // is efficiency per fuel type - if can swap fuels => preserve efficiency rest of vehicle?
         float private_passenger_km;
         float public_passenger_km; 
         float freight_ton_km;
         /*something about congestion, value of travel time,  ...? help to solve social cost issue - but would need range of travelers / income
          * also need assumption about pollution, health, noise benefits?
          * note rebound effect on demand if effic increases...
          */
     }

} //end class transport
